<?php

define('MOBIL', 'mobility');
define('DEPTH', 'depth');
define('SPEED', 'speed');

define('ACT_STOP', '停止');
define('ACT_SILT_UP', '無音浮上');
define('ACT_UP', '通常浮上');
define('ACT_S_UP', '急速浮上');
define('ACT_SLD_UP', 'シールド上昇');
define('ACT_SILT_DOWN', '無音潜航');
define('ACT_DOWN', '通常潜航');
define('ACT_S_DOWN', '急速潜航');
define('ACT_SLD_DOWN', 'シールドダイブ');
define('ACT_START_SPDUP', '増速開始');
define('ACT_SPDUP', '増速');
define('ACT_SLD_SPDUP', 'シールドダッシュ');
define('ACT_SPDDOWM', '減速');
define('ACT_SPDDOWM_C', '減速継続');
define('ACT_SPDDOWM_S', '大減速');
define('ACT_EMERGECRUISE', '浮上巡航');
define('ACT_DIVECRUISE', '潜航巡航');
define('ACT_TURN', '旋回');
define('ACT_S_TURN', '急旋回');
define('ACT_V_TURN', '垂直旋回');
define('ACT_BARREL_ROLL', 'バレルロール');
define('ACT_IMLN_TURN', 'インメルマン旋回');
define('ACT_DEP_P', '深度+');
define('ACT_DEP_PP', '深度++');
define('ACT_DEP_M', '深度-');
define('ACT_DEP_MM', '深度--');
define('ACT_SPD_P', '速度+');
define('ACT_SPD_PP', '速度++');
define('ACT_SPD_M', '速度-');
define('ACT_SPD_MM', '速度--');
define('ACT_MBL_P', '機動+');
define('ACT_MBL_PP', '機動++');
define('ACT_MBL_M', '機動-');
define('ACT_MBL_MM', '機動--');
define('ACT_DS_PM', '深度+ 速度-');
define('ACT_SM_PM', '速度+ 機動-');
define('ACT_MD_PM', '機動+ 深度-');
define('ACT_SLD_OFF', 'シールドOFF');
define('ACT_SLD_ON', 'シールドON');
define('ACT_SLD_MAX', 'シールドMAX');
define('ACT_SLD_TURN', 'シールドターン');

define('MOVE_MSG_STOP', '停止');
define('MOVE_MSG_NONE', 'ただよう');

define('CMDS_NAME', 0);
define('CMDS_TOPOLOGY', 1);
define('CMDS_NEXT', 2);

define('SHIELD_OFF', 0);
define('SHIELD_ON', 1);
define('SHIELD_MAX', 2);

class Topology {
	const mobil_max = MOBIL_MAX;
	const depth_max = DEPTH_MAX;
	const speed_max = SPEED_MAX;
	
	const mobil_key = MOBIL;
	const depth_key = DEPTH;
	const speed_key = SPEED;
	
	public function __construct($mobility = 0, $depth = 0, $speed = 0) {
		$this->mobil = $mobility;
		$this->depth = $depth;
		$this->speed = $speed;
		$this->topology = array(self::mobil_key => &$this->mobil, self::depth_key => &$this->depth, self::speed_key => &$this->speed);
	}
	
	protected $topology, $mobil, $depth, $speed;
	
	public function __get($name) {
		$vars = get_object_vars($this);
		if (isset($vars[$name]))
			return $vars[$name];
		else
			return null;
	}
	
	public function addInt($m, $d, $s) {
		$this->mobil += $m;
		if ($this->mobil < 0)
			$this->mobil = 0;
		elseif ($this->mobil > self::mobil_max)
			$this->mobil = self::mobil_max;
		
		$this->depth += $d;
		if ($this->depth < 0)
			$this->depth = 0;
		elseif ($this->depth > self::depth_max)
			$this->depth = self::depth_max;
		
		$this->speed += $s;
		if ($this->speed < 0)
			$this->speed = 0;
		elseif ($this->speed > self::speed_max)
			$this->speed = self::speed_max;
		
		return $this->topology;
	}
	
	public function addTopology(Topology &$t) {
		return $this->addInt($t->mobil, $t->depth, $t->speed);
	}
	
	public function add(array &$t) {
		return $this->addInt($t[self::mobil_key], $t[self::depth_key], $t[self::speed_key]);
	}
	
	public function setInt($m, $d, $s) {
		$this->mobil = $m;
		$this->depth = $d;
		$this->speed = $s;
		
		return $this->topology;
	}
	
	public function setTopology(Topology &$t) {
		return $this->setInt($t->mobil, $t->depth, $t->speed);
	}
	
	public function get() {
		return $this->topology;
	}
	
	public function set(array &$t) {
		return $this->setInt($t[self::mobil_key], $t[self::depth_key], $t[self::speed_key]);
	}
	
	public function compareInt($m, $d, $s) {
		$m += $this->mobil;
		if ($m < 0)
			$m = 0;
		elseif ($m > self::mobil_max)
			$m = self::mobil_max;
		
		$d += $this->depth;
		if ($d < 0)
			$d = 0;
		elseif ($d > self::depth_max)
			$d = self::depth_max;
		
		$s += $this->speed;
		if ($s < 0)
			$s = 0;
		elseif ($s > self::speed_max)
			$s = self::speed_max;
		
		return new Topology($m, $d, $s);
	}
	
	public function compareTopology(Topology &$t) {
		return $this->compareInt($t->mobil, $t->depth, $t->speed);
	}
	
	public function compare(array &$t) {
		return $this->compareInt($t[self::mobil_key], $t[self::depth_key], $t[self::speed_key]);
	}
	
	public function diffInt($m, $d, $s) {
		return new Topology($m - $this->mobil, $d - $this->depth, $s - $this->speed);
	}
	
	public function diffTopology(Topology &$t) {
		return $this->diffInt($t->mobil, $t->depth, $t->speed);
	}
	
	public function diff(array &$t) {
		return $this->diffInt($t[self::mobil_key], $t[self::depth_key], $t[self::speed_key]);
	}
	
	public function absDiffInt($m, $d, $s) {
		return new Topology(abs($m - $this->mobil), abs($d - $this->depth), abs($s - $this->speed));
	}
	
	public function absDiffTopology(Topology &$t) {
		return $this->absDiffInt($t->mobil, $t->depth, $t->speed);
	}
	
	public function absDiff(array &$t) {
		return $this->absDiffInt($t[self::mobil_key], $t[self::depth_key], $t[self::speed_key]);
	}
	
	public function max() {
		return max($this->topology);
	}
	
	public function min() {
		return min($this->topology);
	}
	
	public function sum() {
		return array_sum($this->topology);
	}
}


abstract class Object extends Topology {
	public function __construct($id, &$pid, $name, &$color, $durab, $mobility = 0, $depth = 0, $speed = 0) {
		parent::__construct($mobility, $depth, $speed);
		
		$this->id = $id;
		$this->pid = &$pid;
		$this->name = $name;
		$this->durab = ($durab < 0)? 0: $durab;
		$this->color = $color;
	}
	
	public $name, $durab, $id, $pid, $color;
	
	//abstract public function move($action = null, $test = false);
	
	protected static $action_messages = array(
		ACT_STOP => 'その場に停止',
		ACT_SILT_UP => '音もなく浮上',
		ACT_UP => '泡をたてながら浮上',
		ACT_S_UP => 'けたたましく急浮上',
		ACT_SLD_UP => 'シールドを広げ急浮上',
		ACT_SILT_DOWN => '音もなく潜航',
		ACT_DOWN => '泡をたてながら潜航',
		ACT_S_DOWN => '急速に潜航',
		ACT_SLD_DOWN => 'シールドを広げ急潜航',
		ACT_START_SPDUP => '加速を開始',
		ACT_SPDUP => 'さらに加速を続行',
		ACT_SLD_SPDUP => 'シールドダッシュを行う',
		ACT_SPDDOWM => '減速を行う',
		ACT_SPDDOWM_C => 'さらに減速を続行',
		ACT_SPDDOWM_S => '大きく速度を下げる',
		ACT_EMERGECRUISE => '浮上しながら速度を下げる',
		ACT_DIVECRUISE => '潜航しながら速度を上げる',
		ACT_TURN => '減速しながら回り込む',
		ACT_S_TURN => '激しい動きで旋回',
		ACT_V_TURN => '一気に減速、そして旋回',
		ACT_BARREL_ROLL => 'バレルロールを行う',
		ACT_IMLN_TURN => 'インメルマン旋回を行う',
		ACT_DEP_P => '潜航',
		ACT_DEP_PP => '深く潜航',
		ACT_DEP_M => '浮上',
		ACT_DEP_MM => '大きく浮上',
		ACT_SPD_P => '速度を上げる',
		ACT_SPD_PP => '大きく速度を上げる',
		ACT_SPD_M => '速度を下げる',
		ACT_SPD_MM => '大きく速度を下げる',
		ACT_MBL_P => '回り込む',
		ACT_MBL_PP => '大きく回り込む',
		ACT_MBL_M => '直線的な動きを行う',
		ACT_MBL_MM => '一直線な動きを行う',
		ACT_DS_PM => 'ゆっくりと潜航',
		ACT_SM_PM => '安定しながら速度を上げる',
		ACT_MD_PM => '回り込みながら浮上',
		ACT_SLD_OFF => 'シールドを切る',
		ACT_SLD_ON => 'シールドを展帳する',
		ACT_SLD_MAX => 'シールドを戦闘展帳する',
		ACT_SLD_TURN => 'シールドターンを行う'
	);
	
	public function turnOrder() {
		return (($this->speed + $this->mobil) - ($this->depth / 2));
	}
}

class Mine extends Object {
	public function __construct($id, &$pid, $name, &$color, $mobility, $depth, $speed) {
		parent::__construct($id, &$pid, $name, &$color, self::life, $mobility, $depth, $speed);
	}
	
	const life = MINE_LIFE;
	
	public function move() {
			$this->addInt(mt_rand(-1, 1), mt_rand(-1, 1), mt_rand(-1, 1));
			return MOVE_MSG_NONE;
	}
}

class Torpedo extends Object {
	public function __construct($id, &$pid, $name, &$color, $mobility, $depth, $speed) {
		parent::__construct($id, &$pid, $name, &$color, self::life, $mobility, $depth, $speed);
		
		$this->last_action = ACT_STOP;
	}
	
	const life = TORPEDO_LIFE;
	
	public static $action_commands = array(
			ACT_STOP => array(CMDS_NAME => ACT_STOP, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_DEP_M, ACT_SPD_P, ACT_SPD_M, ACT_MBL_P, ACT_MBL_M, ACT_DS_PM, ACT_SM_PM, ACT_MD_PM)),
			ACT_DEP_P => array(CMDS_NAME => ACT_DEP_P, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 2, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_DEP_PP, ACT_DEP_M, ACT_SPD_M, ACT_MBL_P, ACT_MBL_M)),
			ACT_DEP_PP => array(CMDS_NAME => ACT_DEP_PP, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 4, Topology::speed_key => 0), CMDS_NEXT => array(ACT_DEP_P, ACT_DEP_PP, ACT_SPD_M, ACT_MBL_M, ACT_DS_PM)),
			ACT_DEP_M => array(CMDS_NAME => ACT_DEP_M, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => -3, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_DEP_M, ACT_DEP_MM, ACT_SPD_P, ACT_SPD_M, ACT_MBL_P)),
			ACT_DEP_MM => array(CMDS_NAME => ACT_DEP_MM, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => -5, Topology::speed_key => 0), CMDS_NEXT => array(ACT_DEP_M, ACT_DEP_MM, ACT_SPD_P, ACT_MBL_P, ACT_MD_PM)),
			ACT_SPD_P => array(CMDS_NAME => ACT_SPD_P, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => 2), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_DEP_M, ACT_SPD_P, ACT_SPD_PP, ACT_SPD_M, ACT_MBL_M)),
			ACT_SPD_PP => array(CMDS_NAME => ACT_SPD_PP, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => 4), CMDS_NEXT => array(ACT_DEP_M, ACT_SPD_P, ACT_SPD_PP, ACT_MBL_M, ACT_SM_PM)),
			ACT_SPD_M => array(CMDS_NAME => ACT_SPD_M, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => -3), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_SPD_P, ACT_SPD_M, ACT_SPD_MM, ACT_MBL_P, ACT_MBL_M, ACT_DS_PM)),
			ACT_SPD_MM => array(CMDS_NAME => ACT_SPD_MM, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => -5), CMDS_NEXT => array(ACT_DEP_P, ACT_SPD_M, ACT_SPD_MM, ACT_MBL_P)),
			ACT_MBL_P => array(CMDS_NAME => ACT_MBL_P, CMDS_TOPOLOGY => array(Topology::mobil_key => 2, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_M, ACT_SPD_P, ACT_SPD_M, ACT_MBL_P, ACT_MBL_PP, ACT_MBL_M)),
			ACT_MBL_PP => array(CMDS_NAME => ACT_MBL_PP, CMDS_TOPOLOGY => array(Topology::mobil_key => 4, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_DEP_M, ACT_SPD_M, ACT_MBL_P, ACT_MBL_PP, ACT_MD_PM)),
			ACT_MBL_M => array(CMDS_NAME => ACT_MBL_M, CMDS_TOPOLOGY => array(Topology::mobil_key => -3, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_DEP_M, ACT_SPD_P, ACT_MBL_M, ACT_MBL_MM)),
			ACT_MBL_MM => array(CMDS_NAME => ACT_MBL_MM, CMDS_TOPOLOGY => array(Topology::mobil_key => -5, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_DEP_P, ACT_SPD_P, ACT_MBL_M, ACT_MBL_MM, ACT_SM_PM)),
			ACT_DS_PM => array(CMDS_NAME => ACT_DS_PM, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 1, Topology::speed_key => -2), CMDS_NEXT => array(ACT_STOP, ACT_DEP_PP, ACT_SPD_PP, ACT_DS_PM)),
			ACT_SM_PM => array(CMDS_NAME => ACT_SM_PM, CMDS_TOPOLOGY => array(Topology::mobil_key => -2, Topology::depth_key => 0, Topology::speed_key => 1), CMDS_NEXT => array(ACT_STOP, ACT_SPD_PP, ACT_MBL_MM, ACT_DS_PM)),
			ACT_MD_PM => array(CMDS_NAME => ACT_MD_PM, CMDS_TOPOLOGY => array(Topology::mobil_key => 1, Topology::depth_key => -2, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_MM, ACT_MBL_PP, ACT_MD_PM)),
		);
	
	public $last_action;
	
	public function getActionList($last_action = null) {
		return self::$action_commands[($last_action? $last_action: $this->last_action)][CMDS_NEXT];
	}
	
	public function move($action) {
			$this->last_action = $action;
			$this->add(self::$action_commands[$action][CMDS_TOPOLOGY]);
			return self::$action_messages[$action];
	}
}

class RoundBuckler extends Object {
	public function __construct($id, &$pid, $name, &$color, $mobility, $depth, $speed) {
		parent::__construct($id, &$pid, $name, &$color, self::durab_max, $mobility, $depth, $speed);
		
		$this->last_action = ACT_STOP;
		$this->shield = self::shield_on;
	}
	
	const durab_max = RB_DURABILITY;
	const shield_off = SHIELD_OFF;
	const shield_on = SHIELD_ON;
	const shield_max = SHIELD_MAX;
	
	public static $action_commands = array(
			ACT_STOP => array(CMDS_NAME => ACT_STOP, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_UP, ACT_SILT_DOWN, ACT_DOWN, ACT_START_SPDUP, ACT_SPDDOWM, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_DEP_P, ACT_DEP_M, ACT_SPD_P, ACT_SPD_M, ACT_MBL_P, ACT_MBL_M, ACT_DS_PM, ACT_SM_PM, ACT_MD_PM, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX)),
			ACT_SILT_UP => array(CMDS_NAME => ACT_SILT_UP, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => -2, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_UP, ACT_START_SPDUP, ACT_SPDDOWM, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX)),
			ACT_UP => array(CMDS_NAME => ACT_UP, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => -4, Topology::speed_key => -1), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_UP, ACT_S_UP, ACT_START_SPDUP, ACT_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_S_UP => array(CMDS_NAME => ACT_S_DOWN, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => -6, Topology::speed_key => -2), CMDS_NEXT => array(ACT_UP, ACT_S_UP, ACT_SLD_UP, ACT_START_SPDUP, ACT_SPDUP, ACT_SLD_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_SPDDOWM_S, ACT_EMERGECRUISE, ACT_TURN, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SLD_UP => array(CMDS_NAME => ACT_SLD_UP, CMDS_TOPOLOGY => array(Topology::mobil_key => 1, Topology::depth_key => -8, Topology::speed_key => -3), CMDS_NEXT => array(ACT_SPDUP, ACT_SLD_SPDUP, ACT_SPDDOWM_C, ACT_SPDDOWM_S, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_DEP_M, ACT_DEP_MM, ACT_SLD_TURN)),
			ACT_SILT_DOWN => array(CMDS_NAME => ACT_SILT_DOWN, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 1, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_SILT_DOWN, ACT_DOWN, ACT_START_SPDUP, ACT_SPDDOWM, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX)),
			ACT_DOWN => array(CMDS_NAME => ACT_DOWN, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 3, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_SILT_DOWN, ACT_DOWN, ACT_S_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_S_DOWN => array(CMDS_NAME => ACT_S_DOWN, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 5, Topology::speed_key => 1), CMDS_NEXT => array(ACT_UP, ACT_S_UP, ACT_SLD_UP, ACT_DOWN, ACT_S_DOWN, ACT_SLD_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SLD_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_SPDDOWM_S, ACT_EMERGECRUISE, ACT_TURN, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SLD_DOWN => array(CMDS_NAME => ACT_SLD_DOWN, CMDS_TOPOLOGY => array(Topology::mobil_key => -1, Topology::depth_key => 7, Topology::speed_key => 3), CMDS_NEXT => array(ACT_S_UP, ACT_SLD_UP, ACT_S_DOWN, ACT_SLD_DOWN, ACT_SPDDOWM_S, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_DEP_P, ACT_DEP_PP, ACT_SLD_TURN)),
			ACT_START_SPDUP => array(CMDS_NAME => ACT_START_SPDUP, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => 1), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_UP, ACT_S_UP, ACT_SILT_DOWN, ACT_DOWN, ACT_S_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_EMERGECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SPDUP => array(CMDS_NAME => ACT_SPDUP, CMDS_TOPOLOGY => array(Topology::mobil_key => -1, Topology::depth_key => 0, Topology::speed_key => 3), CMDS_NEXT => array(ACT_UP, ACT_S_UP, ACT_SLD_UP, ACT_DOWN, ACT_S_DOWN, ACT_SLD_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SLD_SPDUP, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SLD_SPDUP => array(CMDS_NAME => ACT_SLD_SPDUP, CMDS_TOPOLOGY => array(Topology::mobil_key => -2, Topology::depth_key => 0, Topology::speed_key => 6), CMDS_NEXT => array(ACT_S_UP, ACT_SLD_UP, ACT_S_DOWN, ACT_SLD_DOWN, ACT_SPDUP, ACT_SLD_SPDUP, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SPD_P, ACT_SPD_PP, ACT_SLD_TURN)),
			ACT_SPDDOWM => array(CMDS_NAME => ACT_SPDDOWM, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => -2), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_UP, ACT_S_UP, ACT_SILT_DOWN, ACT_DOWN, ACT_S_DOWN, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SPDDOWM_C => array(CMDS_NAME => ACT_SPDDOWM_C, CMDS_TOPOLOGY => array(Topology::mobil_key => 1, Topology::depth_key => 0, Topology::speed_key => -4), CMDS_NEXT => array(ACT_UP, ACT_S_UP, ACT_SLD_UP, ACT_DOWN, ACT_S_DOWN, ACT_SLD_DOWN, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_SPDDOWM_S, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SPDDOWM_S => array(CMDS_NAME => ACT_SPDDOWM_S, CMDS_TOPOLOGY => array(Topology::mobil_key => 2, Topology::depth_key => 0, Topology::speed_key => -6), CMDS_NEXT => array(ACT_S_UP, ACT_SLD_UP, ACT_S_DOWN, ACT_SLD_DOWN, ACT_SPDDOWM_C, ACT_SPDDOWM_S, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SPD_M, ACT_SPD_MM, ACT_SLD_TURN)),
			ACT_EMERGECRUISE => array(CMDS_NAME => ACT_EMERGECRUISE, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => -2, Topology::speed_key => -2), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_SILT_DOWN, ACT_UP, ACT_S_UP, ACT_DOWN, ACT_S_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_DIVECRUISE => array(CMDS_NAME => ACT_DIVECRUISE, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 2, Topology::speed_key => 2), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_UP, ACT_S_UP, ACT_SILT_DOWN, ACT_DOWN, ACT_S_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_TURN => array(CMDS_NAME => ACT_TURN, CMDS_TOPOLOGY => array(Topology::mobil_key => 1, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_UP, ACT_S_UP, ACT_SILT_DOWN, ACT_DOWN, ACT_S_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_S_TURN => array(CMDS_NAME => ACT_S_TURN, CMDS_TOPOLOGY => array(Topology::mobil_key => 3, Topology::depth_key => 0, Topology::speed_key => -1), CMDS_NEXT => array(ACT_UP, ACT_S_UP, ACT_SLD_UP, ACT_DOWN, ACT_S_DOWN, ACT_SLD_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SLD_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_SPDDOWM_S, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_V_TURN => array(CMDS_NAME => ACT_V_TURN, CMDS_TOPOLOGY => array(Topology::mobil_key => 6, Topology::depth_key => 0, Topology::speed_key => -2), CMDS_NEXT => array(ACT_S_UP, ACT_SLD_UP, ACT_S_DOWN, ACT_SLD_DOWN, ACT_SPDUP, ACT_SLD_SPDUP, ACT_SPDDOWM_C, ACT_SPDDOWM_S, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_MBL_P, ACT_MBL_PP, ACT_SLD_TURN)),
			ACT_BARREL_ROLL => array(CMDS_NAME => ACT_BARREL_ROLL, CMDS_TOPOLOGY => array(Topology::mobil_key => 3, Topology::depth_key => 2, Topology::speed_key => 2), CMDS_NEXT => array(ACT_UP, ACT_S_UP, ACT_SLD_UP, ACT_DOWN, ACT_S_DOWN, ACT_SLD_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SLD_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_SPDDOWM_S, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_IMLN_TURN => array(CMDS_NAME => ACT_IMLN_TURN, CMDS_TOPOLOGY => array(Topology::mobil_key => -4, Topology::depth_key => -3, Topology::speed_key => -3), CMDS_NEXT => array(ACT_UP, ACT_S_UP, ACT_SLD_UP, ACT_DOWN, ACT_S_DOWN, ACT_SLD_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SLD_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_SPDDOWM_S, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_DEP_P => array(CMDS_NAME => ACT_DEP_P, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 2, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_DEP_PP, ACT_DEP_M, ACT_SPD_M, ACT_MBL_P, ACT_MBL_M, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_DEP_PP => array(CMDS_NAME => ACT_DEP_PP, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 4, Topology::speed_key => 0), CMDS_NEXT => array(ACT_DEP_P, ACT_DEP_PP, ACT_SPD_M, ACT_MBL_M, ACT_DS_PM, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_DEP_M => array(CMDS_NAME => ACT_DEP_M, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => -3, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_DEP_M, ACT_DEP_MM, ACT_SPD_P, ACT_SPD_M, ACT_MBL_P, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_DEP_MM => array(CMDS_NAME => ACT_DEP_MM, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => -5, Topology::speed_key => 0), CMDS_NEXT => array(ACT_DEP_M, ACT_DEP_MM, ACT_SPD_P, ACT_MBL_P, ACT_MD_PM, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SPD_P => array(CMDS_NAME => ACT_SPD_P, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => 2), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_DEP_M, ACT_SPD_P, ACT_SPD_PP, ACT_SPD_M, ACT_MBL_M, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SPD_PP => array(CMDS_NAME => ACT_SPD_PP, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => 4), CMDS_NEXT => array(ACT_DEP_M, ACT_SPD_P, ACT_SPD_PP, ACT_MBL_M, ACT_SM_PM, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SPD_M => array(CMDS_NAME => ACT_SPD_M, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => -3), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_SPD_P, ACT_SPD_M, ACT_SPD_MM, ACT_MBL_P, ACT_MBL_M, ACT_DS_PM, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SPD_MM => array(CMDS_NAME => ACT_SPD_MM, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => -5), CMDS_NEXT => array(ACT_DEP_P, ACT_SPD_M, ACT_SPD_MM, ACT_MBL_P, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_MBL_P => array(CMDS_NAME => ACT_MBL_P, CMDS_TOPOLOGY => array(Topology::mobil_key => 2, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_M, ACT_SPD_P, ACT_SPD_M, ACT_MBL_P, ACT_MBL_PP, ACT_MBL_M, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_MBL_PP => array(CMDS_NAME => ACT_MBL_PP, CMDS_TOPOLOGY => array(Topology::mobil_key => 4, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_DEP_M, ACT_SPD_M, ACT_MBL_P, ACT_MBL_PP, ACT_MD_PM, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_MBL_M => array(CMDS_NAME => ACT_MBL_M, CMDS_TOPOLOGY => array(Topology::mobil_key => -3, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_P, ACT_DEP_M, ACT_SPD_P, ACT_MBL_M, ACT_MBL_MM, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_MBL_MM => array(CMDS_NAME => ACT_MBL_MM, CMDS_TOPOLOGY => array(Topology::mobil_key => -5, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_DEP_P, ACT_SPD_P, ACT_MBL_M, ACT_MBL_MM, ACT_SM_PM, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_DS_PM => array(CMDS_NAME => ACT_DS_PM, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 1, Topology::speed_key => -2), CMDS_NEXT => array(ACT_STOP, ACT_DEP_PP, ACT_SPD_PP, ACT_DS_PM)),
			ACT_SM_PM => array(CMDS_NAME => ACT_SM_PM, CMDS_TOPOLOGY => array(Topology::mobil_key => -2, Topology::depth_key => 0, Topology::speed_key => 1), CMDS_NEXT => array(ACT_STOP, ACT_SPD_PP, ACT_MBL_MM, ACT_DS_PM)),
			ACT_MD_PM => array(CMDS_NAME => ACT_MD_PM, CMDS_TOPOLOGY => array(Topology::mobil_key => 1, Topology::depth_key => -2, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_DEP_MM, ACT_MBL_PP, ACT_MD_PM)),
			ACT_SLD_OFF => array(CMDS_NAME => ACT_SLD_OFF, CMDS_TOPOLOGY => array(Topology::mobil_key => -2, Topology::depth_key => -3, Topology::speed_key => -4), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_UP, ACT_S_UP, ACT_SILT_DOWN, ACT_DOWN, ACT_S_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_DEP_P, ACT_DEP_M, ACT_SPD_P, ACT_SPD_M, ACT_MBL_P, ACT_MBL_M, ACT_SLD_ON, ACT_SLD_MAX)),
			ACT_SLD_ON => array(CMDS_NAME => ACT_SLD_ON, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_UP, ACT_S_UP, ACT_SILT_DOWN, ACT_DOWN, ACT_S_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_DEP_P, ACT_DEP_M, ACT_SPD_P, ACT_SPD_M, ACT_MBL_P, ACT_MBL_M, ACT_SLD_OFF, ACT_SLD_MAX, ACT_SLD_TURN)),
			ACT_SLD_MAX => array(CMDS_NAME => ACT_SLD_MAX, CMDS_TOPOLOGY => array(Topology::mobil_key => 0, Topology::depth_key => 0, Topology::speed_key => 0), CMDS_NEXT => array(ACT_STOP, ACT_SILT_UP, ACT_UP, ACT_S_UP, ACT_SILT_DOWN, ACT_DOWN, ACT_S_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_DEP_P, ACT_DEP_M, ACT_SPD_P, ACT_SPD_M, ACT_MBL_P, ACT_MBL_M, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_TURN)),
			ACT_SLD_TURN => array(CMDS_NAME => ACT_SLD_TURN, CMDS_TOPOLOGY => array(Topology::mobil_key => 5, Topology::depth_key => 0, Topology::speed_key => -5), CMDS_NEXT => array(ACT_UP, ACT_S_UP, ACT_SLD_UP, ACT_DOWN, ACT_S_DOWN, ACT_SLD_DOWN, ACT_START_SPDUP, ACT_SPDUP, ACT_SLD_SPDUP, ACT_SPDDOWM, ACT_SPDDOWM_C, ACT_SPDDOWM_S, ACT_EMERGECRUISE, ACT_DIVECRUISE, ACT_TURN, ACT_S_TURN, ACT_V_TURN, ACT_BARREL_ROLL, ACT_IMLN_TURN, ACT_SLD_OFF, ACT_SLD_ON, ACT_SLD_MAX, ACT_SLD_TURN))
		);
		
	public $last_action, $shield;
	private $action_list;
	
	public function getActionList($last_action = null, &$topology = null, $shield = null) {
		
		$is_save = ($last_action == null and $topology == null and $shield == null);
			
		if ($last_action == null)
			$last_action =& $this->last_action;
		if ($topology == null)
			$topology =& $this->topology;
		if ($shield == null)
			$shield =& $this->shield;
		
		$sct_cmds = self::$action_commands[$last_action][CMDS_NEXT];
		if ($topology[Topology::speed_key] > 20) {
			if ($key = array_search(ACT_EMERGECRUISE, $sct_cmds))
				unset($sct_cmds[$key]);
			if ($key = array_search(ACT_DIVECRUISE, $sct_cmds))
				unset($sct_cmds[$key]);
		}
		if ($shield == self::shield_off or $last_action == ACT_SLD_OFF) {
			if ($key = array_search(ACT_SLD_UP, $sct_cmds))
				unset($sct_cmds[$key]);
			if ($key = array_search(ACT_SLD_DOWN, $sct_cmds))
				unset($sct_cmds[$key]);
			if ($key = array_search(ACT_SLD_SPDUP, $sct_cmds))
				unset($sct_cmds[$key]);
			if ($key = array_search(ACT_SLD_OFF, $sct_cmds))
				unset($sct_cmds[$key]);
			if ($key = array_search(ACT_SLD_TURN, $sct_cmds))
				unset($sct_cmds[$key]);
		} else {
			if ($key = array_search(ACT_SILT_UP, $sct_cmds))
				unset($sct_cmds[$key]);
			if ($key = array_search(ACT_SILT_DOWN, $sct_cmds))
				unset($sct_cmds[$key]);
			if ($shield == self::shield_on or $last_action == ACT_SLD_ON) {
				if ($key = array_search(ACT_SLD_ON, $sct_cmds))
					unset($sct_cmds[$key]);
			} elseif ($shield == self::shield_max or $last_action == ACT_SLD_MAX) {
				if ($key = array_search(ACT_SLD_MAX, $sct_cmds))
					unset($sct_cmds[$key]);
			}
		}
		if ($this->durab < self::durab_max * 0.4) {
			if ($key = array_search(ACT_SLD_ON, $sct_cmds))
				unset($sct_cmds[$key]);
			if ($key = array_search(ACT_SLD_MAX, $sct_cmds))
				unset($sct_cmds[$key]);
			if ($key = array_search(ACT_SLD_TURN, $sct_cmds))
				unset($sct_cmds[$key]);
		}
		if ($is_save)
			$this->action_list = $sct_cmds;
		return $sct_cmds;
	}
	
	public function move(&$is_depth_over, $action_num) {
		if (!$this->action_list)
			$act_list = $this->action_list;
		else
			$act_list = $this->getActionList();
		if (!isset($act_list[$action_num]))
			return null;
		$this->action_list = null;
		$action = $act_list[$action_num];
		$is_depth_over =  (self::$action_commands[$action][CMDS_TOPOLOGY][Topology::depth_key] + $this->depth > Topology::depth_max);
		$this->last_action = $action;
		if (ACT_SLD_OFF == $this->last_action)
			$this->shield = self::shield_off;
		elseif (ACT_SLD_ON == $this->last_action)
			$this->shield = self::shield_on;
		elseif (ACT_SLD_MAX == $this->last_action)
			$this->shield = self::shield_max;
		$this->add(self::$action_commands[$action][CMDS_TOPOLOGY]);
		return self::$action_messages[$action];
	}
	
	public function isDepthOver($action) {
		return (self::$action_commands[$action][CMDS_TOPOLOGY][Topology::depth_key] + $this->depth > self::depth_max);
	}
}

?>